--  TG_HISTORY_DETAIL 操作历史记录表
DROP PROCEDURE IF EXISTS create_table_and_add_column_TG_HISTORY_DETAIL;
DELIMITER //
CREATE PROCEDURE create_table_and_add_column_TG_HISTORY_DETAIL()
BEGIN
    SET
        @exists_table = (SELECT COUNT(1)
                         FROM information_schema.tables
                         WHERE TABLE_NAME = 'TG_HISTORY_DETAIL');
    IF @exists_table = 0 THEN
        BEGIN
            CREATE TABLE TG_HISTORY_DETAIL
            (
`ID` BIGINTDEFAULT AUTO_INCREMENT NOT NULL COMMENT '主键' 
,`BIZ_CLASS`  VARCHAR(100) COMMENT '实体类型' 
,`BIZ_TYPE`  VARCHAR(40) COMMENT '业务类型' 
,`BIZ_FIELD`  VARCHAR(64) COMMENT '业务关联单号的字段' 
,`BIZ_NO`  VARCHAR(64) COMMENT '业务关联单号' 
,`HISTORY_DETAIL` TEXT COMMENT '历史json' 
,`CREATE_TIME`  DATETIME DEFAULT CURRENT_TIMESTAMP  COMMENT '创建时间' 
,`CREATE_USER`  VARCHAR(50) COMMENT '创建人权限平台登录用户名' 

    , PRIMARY KEY (`ID`)

            );
            SELECT 'Table TG_HISTORY_DETAIL added successfully' AS Message;
        END;
        ELSE 
            BEGIN
            SET @column_count = (SELECT COUNT(1)
                                 FROM information_schema.COLUMNS
                                 WHERE  TABLE_NAME = 'TG_HISTORY_DETAIL'
                                   AND COLUMN_NAME = 'ID');

            -- 如果字段不存在，则新增字段
            IF @column_count = 0 THEN
                -- 新增字段的 SQL 语句
                ALTER TABLE TG_HISTORY_DETAIL ADD `ID` BIGINTDEFAULT AUTO_INCREMENT NOT NULL COMMENT '主键' ;

                SELECT 'Column ID added successfully' AS Message;
                -- 如果字段已存在，则返回提示信息
            ELSE
                SELECT 'Column ID already exists' AS Message;
            END IF;
            SET @column_count = (SELECT COUNT(1)
                                 FROM information_schema.COLUMNS
                                 WHERE  TABLE_NAME = 'TG_HISTORY_DETAIL'
                                   AND COLUMN_NAME = 'BIZ_CLASS');

            -- 如果字段不存在，则新增字段
            IF @column_count = 0 THEN
                -- 新增字段的 SQL 语句
                ALTER TABLE TG_HISTORY_DETAIL ADD `BIZ_CLASS`  VARCHAR(100) COMMENT '实体类型' ;

                SELECT 'Column BIZ_CLASS added successfully' AS Message;
                -- 如果字段已存在，则返回提示信息
            ELSE
                SELECT 'Column BIZ_CLASS already exists' AS Message;
            END IF;
            SET @column_count = (SELECT COUNT(1)
                                 FROM information_schema.COLUMNS
                                 WHERE  TABLE_NAME = 'TG_HISTORY_DETAIL'
                                   AND COLUMN_NAME = 'BIZ_TYPE');

            -- 如果字段不存在，则新增字段
            IF @column_count = 0 THEN
                -- 新增字段的 SQL 语句
                ALTER TABLE TG_HISTORY_DETAIL ADD `BIZ_TYPE`  VARCHAR(40) COMMENT '业务类型' ;

                SELECT 'Column BIZ_TYPE added successfully' AS Message;
                -- 如果字段已存在，则返回提示信息
            ELSE
                SELECT 'Column BIZ_TYPE already exists' AS Message;
            END IF;
            SET @column_count = (SELECT COUNT(1)
                                 FROM information_schema.COLUMNS
                                 WHERE  TABLE_NAME = 'TG_HISTORY_DETAIL'
                                   AND COLUMN_NAME = 'BIZ_FIELD');

            -- 如果字段不存在，则新增字段
            IF @column_count = 0 THEN
                -- 新增字段的 SQL 语句
                ALTER TABLE TG_HISTORY_DETAIL ADD `BIZ_FIELD`  VARCHAR(64) COMMENT '业务关联单号的字段' ;

                SELECT 'Column BIZ_FIELD added successfully' AS Message;
                -- 如果字段已存在，则返回提示信息
            ELSE
                SELECT 'Column BIZ_FIELD already exists' AS Message;
            END IF;
            SET @column_count = (SELECT COUNT(1)
                                 FROM information_schema.COLUMNS
                                 WHERE  TABLE_NAME = 'TG_HISTORY_DETAIL'
                                   AND COLUMN_NAME = 'BIZ_NO');

            -- 如果字段不存在，则新增字段
            IF @column_count = 0 THEN
                -- 新增字段的 SQL 语句
                ALTER TABLE TG_HISTORY_DETAIL ADD `BIZ_NO`  VARCHAR(64) COMMENT '业务关联单号' ;

                SELECT 'Column BIZ_NO added successfully' AS Message;
                -- 如果字段已存在，则返回提示信息
            ELSE
                SELECT 'Column BIZ_NO already exists' AS Message;
            END IF;
            SET @column_count = (SELECT COUNT(1)
                                 FROM information_schema.COLUMNS
                                 WHERE  TABLE_NAME = 'TG_HISTORY_DETAIL'
                                   AND COLUMN_NAME = 'HISTORY_DETAIL');

            -- 如果字段不存在，则新增字段
            IF @column_count = 0 THEN
                -- 新增字段的 SQL 语句
                ALTER TABLE TG_HISTORY_DETAIL ADD `HISTORY_DETAIL` TEXT COMMENT '历史json' ;

                SELECT 'Column HISTORY_DETAIL added successfully' AS Message;
                -- 如果字段已存在，则返回提示信息
            ELSE
                SELECT 'Column HISTORY_DETAIL already exists' AS Message;
            END IF;
            SET @column_count = (SELECT COUNT(1)
                                 FROM information_schema.COLUMNS
                                 WHERE  TABLE_NAME = 'TG_HISTORY_DETAIL'
                                   AND COLUMN_NAME = 'CREATE_TIME');

            -- 如果字段不存在，则新增字段
            IF @column_count = 0 THEN
                -- 新增字段的 SQL 语句
                ALTER TABLE TG_HISTORY_DETAIL ADD `CREATE_TIME`  DATETIME DEFAULT CURRENT_TIMESTAMP  COMMENT '创建时间' ;

                SELECT 'Column CREATE_TIME added successfully' AS Message;
                -- 如果字段已存在，则返回提示信息
            ELSE
                SELECT 'Column CREATE_TIME already exists' AS Message;
            END IF;
            SET @column_count = (SELECT COUNT(1)
                                 FROM information_schema.COLUMNS
                                 WHERE  TABLE_NAME = 'TG_HISTORY_DETAIL'
                                   AND COLUMN_NAME = 'CREATE_USER');

            -- 如果字段不存在，则新增字段
            IF @column_count = 0 THEN
                -- 新增字段的 SQL 语句
                ALTER TABLE TG_HISTORY_DETAIL ADD `CREATE_USER`  VARCHAR(50) COMMENT '创建人权限平台登录用户名' ;

                SELECT 'Column CREATE_USER added successfully' AS Message;
                -- 如果字段已存在，则返回提示信息
            ELSE
                SELECT 'Column CREATE_USER already exists' AS Message;
            END IF;

		     END;
	    END IF;
    END//
DELIMITER ;

CALL create_table_and_add_column_TG_HISTORY_DETAIL();
DROP PROCEDURE IF EXISTS create_table_and_add_column_TG_HISTORY_DETAIL;



--  TG_HISTORY_RECORD 操作历史记录表
DROP PROCEDURE IF EXISTS create_table_and_add_column_TG_HISTORY_RECORD;
DELIMITER //
CREATE PROCEDURE create_table_and_add_column_TG_HISTORY_RECORD()
BEGIN
    SET
        @exists_table = (SELECT COUNT(1)
                         FROM information_schema.tables
                         WHERE TABLE_NAME = 'TG_HISTORY_RECORD');
    IF @exists_table = 0 THEN
        BEGIN
            CREATE TABLE TG_HISTORY_RECORD
            (
`ID` BIGINTDEFAULT AUTO_INCREMENT NOT NULL COMMENT '主键' 
,`BIZ_TYPE`  VARCHAR(40) COMMENT '业务类型' 
,`BIZ_FIELD`  VARCHAR(64) COMMENT '业务字段' 
,`BIZ_NO`  VARCHAR(64) COMMENT '业务单号' 
,`HISTORY_RECORD` TEXT COMMENT '历史json的count记录' 

    , PRIMARY KEY (`ID`)

            );
            SELECT 'Table TG_HISTORY_RECORD added successfully' AS Message;
        END;
        ELSE 
            BEGIN
            SET @column_count = (SELECT COUNT(1)
                                 FROM information_schema.COLUMNS
                                 WHERE  TABLE_NAME = 'TG_HISTORY_RECORD'
                                   AND COLUMN_NAME = 'ID');

            -- 如果字段不存在，则新增字段
            IF @column_count = 0 THEN
                -- 新增字段的 SQL 语句
                ALTER TABLE TG_HISTORY_RECORD ADD `ID` BIGINTDEFAULT AUTO_INCREMENT NOT NULL COMMENT '主键' ;

                SELECT 'Column ID added successfully' AS Message;
                -- 如果字段已存在，则返回提示信息
            ELSE
                SELECT 'Column ID already exists' AS Message;
            END IF;
            SET @column_count = (SELECT COUNT(1)
                                 FROM information_schema.COLUMNS
                                 WHERE  TABLE_NAME = 'TG_HISTORY_RECORD'
                                   AND COLUMN_NAME = 'BIZ_TYPE');

            -- 如果字段不存在，则新增字段
            IF @column_count = 0 THEN
                -- 新增字段的 SQL 语句
                ALTER TABLE TG_HISTORY_RECORD ADD `BIZ_TYPE`  VARCHAR(40) COMMENT '业务类型' ;

                SELECT 'Column BIZ_TYPE added successfully' AS Message;
                -- 如果字段已存在，则返回提示信息
            ELSE
                SELECT 'Column BIZ_TYPE already exists' AS Message;
            END IF;
            SET @column_count = (SELECT COUNT(1)
                                 FROM information_schema.COLUMNS
                                 WHERE  TABLE_NAME = 'TG_HISTORY_RECORD'
                                   AND COLUMN_NAME = 'BIZ_FIELD');

            -- 如果字段不存在，则新增字段
            IF @column_count = 0 THEN
                -- 新增字段的 SQL 语句
                ALTER TABLE TG_HISTORY_RECORD ADD `BIZ_FIELD`  VARCHAR(64) COMMENT '业务字段' ;

                SELECT 'Column BIZ_FIELD added successfully' AS Message;
                -- 如果字段已存在，则返回提示信息
            ELSE
                SELECT 'Column BIZ_FIELD already exists' AS Message;
            END IF;
            SET @column_count = (SELECT COUNT(1)
                                 FROM information_schema.COLUMNS
                                 WHERE  TABLE_NAME = 'TG_HISTORY_RECORD'
                                   AND COLUMN_NAME = 'BIZ_NO');

            -- 如果字段不存在，则新增字段
            IF @column_count = 0 THEN
                -- 新增字段的 SQL 语句
                ALTER TABLE TG_HISTORY_RECORD ADD `BIZ_NO`  VARCHAR(64) COMMENT '业务单号' ;

                SELECT 'Column BIZ_NO added successfully' AS Message;
                -- 如果字段已存在，则返回提示信息
            ELSE
                SELECT 'Column BIZ_NO already exists' AS Message;
            END IF;
            SET @column_count = (SELECT COUNT(1)
                                 FROM information_schema.COLUMNS
                                 WHERE  TABLE_NAME = 'TG_HISTORY_RECORD'
                                   AND COLUMN_NAME = 'HISTORY_RECORD');

            -- 如果字段不存在，则新增字段
            IF @column_count = 0 THEN
                -- 新增字段的 SQL 语句
                ALTER TABLE TG_HISTORY_RECORD ADD `HISTORY_RECORD` TEXT COMMENT '历史json的count记录' ;

                SELECT 'Column HISTORY_RECORD added successfully' AS Message;
                -- 如果字段已存在，则返回提示信息
            ELSE
                SELECT 'Column HISTORY_RECORD already exists' AS Message;
            END IF;

		     END;
	    END IF;
    END//
DELIMITER ;

CALL create_table_and_add_column_TG_HISTORY_RECORD();
DROP PROCEDURE IF EXISTS create_table_and_add_column_TG_HISTORY_RECORD;



